unit hiHref;

interface

uses Kol,Share,Win,ShellApi;

type
 ThiHref = class(THIWin)
   private
     procedure SetCaption(const Value:string);
     procedure SetAutoSize(Value:boolean);
     procedure SetAlignment(Value:TTextAlign);
     procedure _OnClick( Sender: PObj );
     procedure _OnMouseEnter( Sender: PObj );
     procedure _OnMouseLeave( Sender: PObj );
   public
     _event_OnClick:THI_Event;
     _prop_urlName:string;
     _prop_ColorHover:integer;
     _prop_Cursor:integer;
     _prop_Underline:boolean;

     _data_Text:THI_Event;
     _data_urlName:THI_Event;

     procedure _work_DoText(var Data:TData; Index:word);
     procedure _var_Caption(var Data:TData; Index:word);

     constructor Create(Parent:PControl);
     property _prop_Caption:string write SetCaption;
     property _prop_AutoSize:boolean write SetAutoSize;
     property _prop_Alignment:TTextAlign write SetAlignment;
 end;

implementation
{
ShellExecute(Form1.Handle, 
                            nil, 
                            'http://www.borland.com', 
                            nil, 
                            nil, 
                            SW_SHOWNORMAL); 
}
constructor ThiHref.Create;
begin
   inherited Create(Parent);
   Control := NewLabel(Parent,'Push');
   Control.OnClick := _OnClick;
   Control.OnMouseEnter:=_OnMouseEnter;
   Control.OnMouseLeave:=_OnMouseLeave;
end;

procedure ThiHref._OnClick;
   var FN:string;
begin
   Fn := _prop_UrlName;
   ShellExecute(0,'open',pchar(fn),'', '',1);
   _hi_OnEvent(_event_OnClick);
end;

procedure ThiHref._OnMouseEnter;
begin
   if _prop_ColorHover <> 0 then
      Control.Font.Color := _prop_ColorHover;
   if _prop_Cursor <> 0 then
      Control.Cursor := _prop_Cursor;
   if _prop_Underline then
      Control.Font.FontStyle := Control.Font.FontStyle + [fsUnderline];
end;

procedure ThiHref._OnMouseLeave;
begin
   if _prop_ColorHover <> 0 then
      Control.Font.Color := _prop_Font.Color;
   if _prop_Cursor <> 0 then
      Control.Cursor := crDefault;
   if _prop_Underline then
      Control.Font.FontStyle := Control.Font.FontStyle - [fsUnderline];
end;

procedure ThiHref._work_DoText;
begin
   Control.Caption := ReadString(Data,_data_Text,'');
end;

procedure ThiHref.SetCaption;
begin
   Control.Caption := Value;
end;

procedure ThiHref.SetAlignment;
begin
  Control.TextAlign := Value;
end;

procedure ThiHref.SetAutoSize;
begin
   Control.AutoSize( Value );
end;

procedure ThiHref._var_Caption;
begin
   Data.Data_type := data_str;
   Data.sdata := Control.Caption;
end;

end.
